$Path = @AutoItExe
While ( STringRight($Path, 1) <> "\" ) 
   $Path = StringTrimRight($Path, 1)
WEnd
$driveLetter = StringLeft(@AutoItExe, 2)
ToolTip("The drive can be ejected when all files are closed.", Default, Default, "Close Any Programs or Files Open on Drive " & $driveletter, Default, 4) 
if $driveLetter = StringLeft(@WindowsDir,2) then Exit ; Can't Eject System Drive
if $driveLetter = StringLeft(@TempDir,2) then Exit ; or the Temp Drive
$drivetype = DriveGetType($driveletter) ; What type of drive are we on
if Not StringInStr(" REMOVABLE CDROM ", $driveType) then Exit ; Not on a Removeable Drive
Sleep(100)
$Start = TimerInit() ; Save the display start time of the tooltip
$Command = 'Rundll32.exe Shell32,Control_RunDLL hotplug.dll'

; uncomment and put removcedrive in ther same dir as this script to use it
; $exec = @TempDir & "\RemoveDrive" & @YDAY & ".exe" ; Name of Executable (Add the day onto it to make it unique, not the best method...)
; $Command = $exec & " " & $driveLetter & " -l -s -b" ; Command to execute, -l = loop untill success, -s = self delete, -b = baloon tip when removed
; FileCopy($Path & "RemoveDrive.exe", $exec) ; Copy the File (Should check failures, but...)

; Try to close any windows that are running off the drive
$var = WinList()
For $i = 1 to $var[0][0]
	$pid = WinGetProcess($var[$i][1])
	$path = _ProcessGetLocation($pid)
	$parent = _GetParent($var[$i][1])

	; OK there has to be a better way than this to get the windows with files open on the drive
	If StringInStr($var[$i][0], $driveLetter) AND $path <> @AutoItExe Then
		WinClose($var[$i][1])
	Else	
		If StringInStr($path, $driveLetter) AND $path <> @AutoItExe Then 
			if ( $parent = 0 ) then ; Only Close the Top Level Windows
;				if ( StringInStr($path, "TunnelierPortable") ) Then
;					if ( ProcessExists($pid) ) Then
;						ProcessClose($pid)
;					EndIf
;				else
					WinClose($var[$i][1])
;				EndIf
			EndIf
		EndIf
	EndIf
Next

$Runtime = TimerDiff($Start)
If $Runtime < 2000 then	Sleep(2000 - $Runtime) ; If tip displayed for less than 2 seconds give it a chance to be seen
if StringInStr(" CDROM ", $driveType) then 
	CDTray($driveletter, "open")
else
	Run($Command, @TempDir, @SW_HIDE ) ; Start the RemoveDrive Process in the background
EndIF

Func _ProcessGetLocation($iPID) ; Get the path of a process executable
    Local $aProc = DllCall('kernel32.dll', 'hwnd', 'OpenProcess', 'int', BitOR(0x0400, 0x0010), 'int', 0, 'int', $iPID)
    If $aProc[0] = 0 Then Return SetError(1, 0, '')
    Local $vStruct = DllStructCreate('int[1024]')
    DllCall('psapi.dll', 'int', 'EnumProcessModules', 'hwnd', $aProc[0], 'ptr', DllStructGetPtr($vStruct), 'int', DllStructGetSize($vStruct), 'int_ptr', 0)
    Local $aReturn = DllCall('psapi.dll', 'int', 'GetModuleFileNameEx', 'hwnd', $aProc[0], 'int', DllStructGetData($vStruct, 1), 'str', '', 'int', 2048)
    If StringLen($aReturn[3]) = 0 Then Return SetError(2, 0, '')
    Return $aReturn[3]
EndFunc

Func _GetParent($hWnd) ; Get a Windows Parent Window
    Local $v_Call = DllCall("user32.dll", "hwnd", "GetParent", "hwnd", $hWnd)
	Return $v_Call[0]
EndFunc

